Index: /trunk/sources/HeuristicLab/3.3/Tests/GeneticAlgorithmSamplesTest.cs
===================================================================
--- /trunk/sources/HeuristicLab/3.3/Tests/GeneticAlgorithmSamplesTest.cs	(revision 6473)
+++ /trunk/sources/HeuristicLab/3.3/Tests/GeneticAlgorithmSamplesTest.cs	(revision 6474)
@@ -97,6 +97,6 @@
       RunAlgorithm(ga);
       Assert.AreEqual(1828.9368669428336, GetDoubleResult(ga, "BestQuality"));
-      Assert.AreEqual(1832.0882694567929, GetDoubleResult(ga, "CurrentAverageQuality"));
-      Assert.AreEqual(1948.386456294867, GetDoubleResult(ga, "CurrentWorstQuality"));
+      Assert.AreEqual(1832.7272021720889, GetDoubleResult(ga, "CurrentAverageQuality"));
+      Assert.AreEqual(1929.5220133155044, GetDoubleResult(ga, "CurrentWorstQuality"));
       Assert.AreEqual(99100, GetIntResult(ga, "EvaluatedSolutions"));
     }
@@ -179,7 +179,7 @@
       RunAlgorithm(ga);
       Assert.AreEqual(89, GetDoubleResult(ga, "BestQuality"));
-      Assert.AreEqual(79.834, GetDoubleResult(ga, "CurrentAverageQuality"));
+      Assert.AreEqual(68.635, GetDoubleResult(ga, "CurrentAverageQuality"));
       Assert.AreEqual(0, GetDoubleResult(ga, "CurrentWorstQuality"));
-      Assert.AreEqual(100900, GetIntResult(ga, "EvaluatedSolutions"));
+      Assert.AreEqual(50950, GetIntResult(ga, "EvaluatedSolutions"));
     }
 
@@ -200,5 +200,5 @@
       ga.Problem = antProblem;
       ConfigureGeneticAlgorithmParameters<TournamentSelector, SubtreeCrossover, MultiSymbolicExpressionTreeArchitectureManipulator>(
-        ga, 1000, 1, 100, 0.15, 5);
+        ga, 1000, 1, 50, 0.15, 5);
       var mutator = (MultiSymbolicExpressionTreeArchitectureManipulator)ga.Mutator;
       mutator.Operators.SetItemCheckedState(mutator.Operators
@@ -230,8 +230,8 @@
       ga.SetSeedRandomly.Value = false;
       RunAlgorithm(ga);
-      Assert.AreEqual(0.87577096276191879, GetDoubleResult(ga, "BestQuality"));
-      Assert.AreEqual(0.65140971696668726, GetDoubleResult(ga, "CurrentAverageQuality"));
+      Assert.AreEqual(0.82895806566669916, GetDoubleResult(ga, "BestQuality"));
+      Assert.AreEqual(0.50808259256341926, GetDoubleResult(ga, "CurrentAverageQuality"));
       Assert.AreEqual(0, GetDoubleResult(ga, "CurrentWorstQuality"));
-      Assert.AreEqual(100900, GetIntResult(ga, "EvaluatedSolutions"));
+      Assert.AreEqual(50950, GetIntResult(ga, "EvaluatedSolutions"));
     }
 
@@ -308,5 +308,5 @@
       symbRegProblem.ValidationPartition.Start = 2800;
       symbRegProblem.ValidationPartition.End = 4000;
-      symbRegProblem.RelativeNumberOfEvaluatedSamples.Value = 0.3;
+      symbRegProblem.RelativeNumberOfEvaluatedSamples.Value = 1;
       symbRegProblem.MaximumSymbolicExpressionTreeLength.Value = 150;
       symbRegProblem.MaximumSymbolicExpressionTreeDepth.Value = 12;
@@ -321,5 +321,5 @@
       ga.Description = "A standard genetic programming algorithm to solve a symbolic regression problem (tower dataset)";
       ConfigureGeneticAlgorithmParameters<TournamentSelector, SubtreeCrossover, MultiSymbolicExpressionTreeManipulator>(
-        ga, 1000, 1, 100, 0.15, 5);
+        ga, 1000, 1, 50, 0.15, 5);
       var mutator = (MultiSymbolicExpressionTreeManipulator)ga.Mutator;
       mutator.Operators.OfType<FullTreeShaker>().Single().ShakingFactor = 0.1;
@@ -330,4 +330,8 @@
         .OfType<SymbolicRegressionSingleObjectiveOverfittingAnalyzer>()
         .Single(), false);
+      ga.Analyzer.Operators.SetItemCheckedState(
+        ga.Analyzer.Operators
+        .OfType<SymbolicDataAnalysisAlleleFrequencyAnalyzer>()
+        .First(), false);
       #endregion
       return ga;
@@ -347,6 +351,6 @@
       ga.SetSeedRandomly.Value = false;
       RunAlgorithm(ga);
-      Assert.AreEqual(0.1385094551576456, GetDoubleResult(ga, "BestQuality"));
-      Assert.AreEqual(2.8817699057253576, GetDoubleResult(ga, "CurrentAverageQuality"));
+      Assert.AreEqual(0.13607488888377872, GetDoubleResult(ga, "BestQuality"));
+      Assert.AreEqual(2.1634701155600293, GetDoubleResult(ga, "CurrentAverageQuality"));
       Assert.AreEqual(100.62175156249987, GetDoubleResult(ga, "CurrentWorstQuality"));
       Assert.AreEqual(100900, GetIntResult(ga, "EvaluatedSolutions"));
@@ -442,4 +446,8 @@
         .OfType<SymbolicClassificationSingleObjectiveOverfittingAnalyzer>()
         .Single(), false);
+      ga.Analyzer.Operators.SetItemCheckedState(
+        ga.Analyzer.Operators
+        .OfType<SymbolicDataAnalysisAlleleFrequencyAnalyzer>()
+        .First(), false);
       #endregion
       return ga;