Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app.config
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app.config	(revision 6469)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app.config	(revision 6478)
@@ -6,15 +6,76 @@
 
   <configSections>
-    <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
-      <section name="HeuristicLab.Clients.Hive.Slave.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false"/>
+    <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
+      <section name="HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false" />
     </sectionGroup>
   </configSections>
   <userSettings>
-    <HeuristicLab.Clients.Hive.Slave.Properties.Settings>
-      <setting name="Guid" serializeAs="String">
-        <value>00000000-0000-0000-0000-000000000000</value>
+    <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
+      <setting name="HeartbeatInterval" serializeAs="String">
+        <value>00:00:10</value>
       </setting>
-    </HeuristicLab.Clients.Hive.Slave.Properties.Settings>
+      <setting name="LastUsedFileName" serializeAs="String">
+        <value>lastUsed.dat</value>
+      </setting>
+      <setting name="PluginCacheDir" serializeAs="String">
+        <value>PluginCache</value>
+      </setting>
+      <setting name="PluginTempBaseDir" serializeAs="String">
+        <value>PluginTemp</value>
+      </setting>
+      <setting name="ConfigurationName" serializeAs="String">
+        <value>Configuration</value>
+      </setting>
+      <setting name="PluginInfrastructureDll" serializeAs="String">
+        <value>HeuristicLab.PluginInfrastructure-3.3.dll</value>
+      </setting>
+      <setting name="SharpZipLibDll" serializeAs="String">
+        <value>ICSharpCode.SharpZipLib.dll</value>
+      </setting>
+      <setting name="SharpZipLibLicense" serializeAs="String">
+        <value>ICSharpCode.SharpZipLib License.txt</value>
+      </setting>
+      <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
+        <value>HeuristicLab.Clients.Hive.SlaveCore-3.4.dll</value>
+      </setting>
+      <setting name="ClientsHiveDll" serializeAs="String">
+        <value>HeuristicLab.Clients.Hive-3.4.dll</value>
+      </setting>
+      <setting name="HiveDll" serializeAs="String">
+        <value>HeuristicLab.Hive-3.4.dll</value>
+      </setting>
+      <setting name="ClientsCommonDll" serializeAs="String">
+        <value>HeuristicLab.Clients.Common-3.3.dll</value>
+      </setting>
+      <setting name="PluginLifetime" serializeAs="String">
+        <value>3</value>
+      </setting>
+      <setting name="DirOpSleepTime" serializeAs="String">
+        <value>00:00:01</value>
+      </setting>
+      <setting name="PluginDeletionRetries" serializeAs="String">
+        <value>5</value>
+      </setting>
+      <setting name="PluginDeletionTimeout" serializeAs="String">
+        <value>00:00:01</value>
+      </setting>
+      <setting name="ExecutorSemTimeouts" serializeAs="String">
+        <value>00:00:46</value>
+      </setting>
+      <setting name="QueuesMaxThreads" serializeAs="String">
+        <value>5000</value>
+      </setting>
+      <setting name="SlaveCommunicationServiceEndpoint" serializeAs="String">
+        <value>SlaveCommunicationServiceEndpoint</value>
+      </setting>
+      <setting name="SlaveUser" serializeAs="String">
+        <value>hiveslave</value>
+      </setting>
+      <setting name="SlavePwd" serializeAs="String">
+        <value>hiveslave</value>
+      </setting>
+    </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
   </userSettings>
+ 
 
   <system.serviceModel>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HiveJobs/OptimizerHiveJob.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HiveJobs/OptimizerHiveJob.cs	(revision 6469)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HiveJobs/OptimizerHiveJob.cs	(revision 6478)
@@ -197,6 +197,6 @@
       }
 
+      childHiveJobsLock.EnterReadLock();
       OptimizerHiveJob child = (OptimizerHiveJob)this.ChildHiveJobs.Single(j => j.Job.Id == childJobId);
-      childHiveJobsLock.EnterReadLock();
       try {
         if (!optimizerJob.ComputeInParallel) {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/RefreshableHiveExperiment.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/RefreshableHiveExperiment.cs	(revision 6469)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/RefreshableHiveExperiment.cs	(revision 6478)
@@ -136,5 +136,5 @@
         jobResultPoller = new JobResultPoller(hiveExperiment.Id, /*ApplicationConstants.ResultPollingInterval*/new TimeSpan(0, 0, 5)); //TODO: find a better place for ApplicationConstants
         RegisterResultPollingEvents();
-        jobResultPoller.AutoResumeOnException = !IsControllable;
+        jobResultPoller.AutoResumeOnException = true;
       }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Interfaces/IHiveDao.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Interfaces/IHiveDao.cs	(revision 6469)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Interfaces/IHiveDao.cs	(revision 6478)
@@ -116,4 +116,5 @@
     IEnumerable<DT.Resource> GetAssignedResources(Guid jobId);
     IEnumerable<DT.Resource> GetParentResources(Guid resourceId);
+    IEnumerable<DT.Resource> GetChildResources(Guid resourceId);
     IEnumerable<DT.Job> GetJobsByResourceId(Guid resourceId);
     #endregion
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/Hive-3.4/Status.aspx
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/Hive-3.4/Status.aspx	(revision 6469)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/Hive-3.4/Status.aspx	(revision 6478)
@@ -125,5 +125,8 @@
       PaletteCustomColors="79, 129, 189">
       <Series>
-        <asp:Series ChartType="Area" Name="Cores" XValueType="DateTime" YValueType="Double">
+        <asp:Series ChartType="Area" Name="Speedup" XValueType="DateTime" YValueType="Double">
+        </asp:Series>
+        <asp:Series BorderWidth="2" ChartArea="ChartArea1" 
+          ChartType="Line" Color="185, 205, 150" Name="Cores">
         </asp:Series>
       </Series>
@@ -147,5 +150,9 @@
     <asp:Chart ID="speedupChartHours" runat="server" Palette="None" Width="1900px" PaletteCustomColors="79, 129, 189">
       <Series>
-        <asp:Series ChartType="Area" Name="Cores" XValueType="DateTime" YValueType="Double">
+        <asp:Series ChartType="Area" Name="Speedup" XValueType="DateTime" 
+          YValueType="Double">
+        </asp:Series>
+        <asp:Series BorderWidth="2" ChartArea="ChartArea1" 
+          ChartType="Line" Color="185, 205, 150" Name="Cores">
         </asp:Series>
       </Series>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/Hive-3.4/Status.aspx.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/Hive-3.4/Status.aspx.cs	(revision 6469)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/Hive-3.4/Status.aspx.cs	(revision 6478)
@@ -14,5 +14,18 @@
   protected void Page_Load(object sender, EventArgs e) {
     var dao = ServiceLocator.Instance.HiveDao;
-    var onlineSlaves = dao.GetSlaves(x => x.SlaveState == SlaveState.Calculating || x.SlaveState == SlaveState.Idle);
+    var resourceName = Request.QueryString["resource"];
+    IEnumerable<Guid> resourceIds;
+    if (!string.IsNullOrEmpty(resourceName)) {
+      var resId = dao.GetResources(x => x.Name == resourceName).Single().Id;
+      resourceIds = dao.GetChildResources(resId).Select(x => x.Id).Union(new List<Guid> { resId });
+      speedupChartHours.Visible = false;
+      speedupChartMinutes.Visible = false;
+    } else {
+      resourceIds = dao.GetResources(x => true).Select(y => y.Id);
+      speedupChartHours.Visible = true;
+      speedupChartMinutes.Visible = true;
+    }
+
+    var onlineSlaves = dao.GetSlaves(x => (x.SlaveState == SlaveState.Calculating || x.SlaveState == SlaveState.Idle) && resourceIds.Contains(x.ResourceId));
 
     int currentlyAvailableCores = onlineSlaves.Sum(s => s.Cores.Value);
@@ -24,5 +37,5 @@
     this.waitingJobsLabel.Text = currentlyJobsWaiting.ToString();
 
-    slavesLabel.Text = string.Join(", ", onlineSlaves.Select(x => string.Format("{0} ({1} %)", x.Name, Math.Round(x.CpuUtilization, 2))));
+    slavesLabel.Text = string.Join(", ", onlineSlaves.Select(x => string.Format("<a href=\"?resource={0}\">{0}</a> ({1} %)", x.Name, Math.Round(x.CpuUtilization, 2))));
 
     cpuUtilizationLabel.Text = (onlineSlaves.Count() > 0 ? Math.Round(onlineSlaves.Average(s => s.CpuUtilization), 2).ToString() : "0.0") + " %";
@@ -30,28 +43,29 @@
     HeuristicLab.Services.Hive.Common.DataTransfer.Statistics[] stats;
     if (daysDropDownList.SelectedValue == "All")
-      stats = dao.GetStatistics(x => true).OrderByDescending(x => x.TimeStamp).ToArray();
+      stats = dao.GetStatistics(x => true).OrderBy(x => x.TimeStamp).ToArray();
     else
-      stats = dao.GetStatistics(x => x.Timestamp >= DateTime.Now.Subtract(TimeSpan.FromDays(int.Parse(daysDropDownList.SelectedValue)))).OrderByDescending(x => x.TimeStamp).ToArray();
+      stats = dao.GetStatistics(x => x.Timestamp >= DateTime.Now.Subtract(TimeSpan.FromDays(int.Parse(daysDropDownList.SelectedValue)))).OrderBy(x => x.TimeStamp).ToArray();
 
     var firstStatisticsDate = DateTime.Parse("2011-05-24 17:16:40");
     var statisticsSince = DateTime.Now - firstStatisticsDate;
-    totalExecutionTimeLabel.Text = new TimeSpan(stats.First().UserStatistics.Sum(x => x.ExecutionTime.Ticks)).ToString() + " (since " + Math.Round(statisticsSince.TotalDays, 2) + " days)";
-
+    totalExecutionTimeLabel.Text = new TimeSpan(stats.Last().UserStatistics.Sum(x => x.ExecutionTime.Ticks)).ToString() + " (since " + Math.Round(statisticsSince.TotalDays, 2) + " days)";
+    
     for (int i = 0; i < stats.Length; i++) {
       var s = stats[i];
+      var slaveStats = s.SlaveStatistics.Where(x => resourceIds.Contains(x.SlaveId));
 
-      var averageCpuUtilization = s.SlaveStatistics.Count() > 0 ? s.SlaveStatistics.Average(x => x.CpuUtilization) : 0.0;
+      var averageCpuUtilization = slaveStats.Count() > 0 ? slaveStats.Average(x => x.CpuUtilization) : 0.0;
       cpuUtilizationChart.Series[0].Points.Add(new DataPoint(s.TimeStamp.ToOADate(), averageCpuUtilization));
 
-      var cores = s.SlaveStatistics.Sum(x => x.Cores);
+      var cores = slaveStats.Sum(x => x.Cores);
 
-      var usedCores = cores - s.SlaveStatistics.Sum(x => x.FreeCores);
+      var usedCores = cores - slaveStats.Sum(x => x.FreeCores);
       coresChart.Series[0].Points.AddXY(s.TimeStamp.ToOADate(), cores);
       coresChart.Series[1].Points.AddXY(s.TimeStamp.ToOADate(), usedCores);
 
-      var memory = s.SlaveStatistics.Sum(x => x.Memory);
-      var usedMemory = memory - s.SlaveStatistics.Sum(x => x.FreeMemory);
-      memoryChart.Series[0].Points.AddXY(s.TimeStamp.ToOADate(), memory/1024);
-      memoryChart.Series[1].Points.AddXY(s.TimeStamp.ToOADate(), usedMemory/1024);
+      var memory = slaveStats.Sum(x => x.Memory);
+      var usedMemory = memory - slaveStats.Sum(x => x.FreeMemory);
+      memoryChart.Series[0].Points.AddXY(s.TimeStamp.ToOADate(), memory / 1024.0);
+      memoryChart.Series[1].Points.AddXY(s.TimeStamp.ToOADate(), usedMemory / 1024.0);
 
       if (i > 0) {
@@ -63,4 +77,5 @@
         var speedup = execTimeDifference.TotalMinutes / timeDifference.TotalMinutes;
         speedupChartMinutes.Series[0].Points.AddXY(s.TimeStamp.ToOADate(), speedup);
+        speedupChartMinutes.Series[1].Points.AddXY(s.TimeStamp.ToOADate(), cores);
       }
       if (i - 60 >= 0) {
@@ -72,4 +87,5 @@
         var speedup = execTimeDifference.TotalMinutes / timeDifference.TotalMinutes;
         speedupChartHours.Series[0].Points.AddXY(s.TimeStamp.ToOADate(), speedup);
+        speedupChartHours.Series[1].Points.AddXY(s.TimeStamp.ToOADate(), cores);
       }
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/Hive-3.4/Web.config
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/Hive-3.4/Web.config	(revision 6469)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/Hive-3.4/Web.config	(revision 6478)
@@ -36,4 +36,8 @@
   </connectionStrings>
   <system.web>
+    <httpHandlers>
+      <add path="ChartImg.axd" verb="GET,HEAD,POST" type="System.Web.UI.DataVisualization.Charting.ChartHttpHandler, System.Web.DataVisualization, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35"
+        validate="false" />
+    </httpHandlers>
     <compilation debug="true" targetFramework="4.0">
       <assemblies>