Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/Query Daily Statistics.sql
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/Query Daily Statistics.sql	(revision 6481)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/Query Daily Statistics.sql	(revision 6481)
@@ -0,0 +1,13 @@
+/****** Script for SelectTopNRows command from SSMS  ******/
+SELECT CONVERT(VARCHAR(10), [DateTime], 104) AS [Day]
+      ,AVG(CAST([Cores] AS FLOAT)) AS Cores
+      ,AVG(CAST([FreeCores] AS FLOAT)) AS FreeCores
+      ,AVG([CpuUtilization]) AS CpuUtilization
+      ,AVG(CAST([Memory] AS FLOAT)) AS Memory
+      ,AVG(CAST([FreeMemory] AS FLOAT)) AS FreeMemory
+      ,MAX([ExecutionTimeHours]) AS [ExecutionTimeHours]
+      ,MAX([ExecutionTimeFinished]) AS [ExecutionTimeFinished]
+      ,MAX([StartToEndTimeFinished]) AS [StartToEndTimeFinished]
+  FROM [HeuristicLab.Hive-3.4].[dbo].[view_Statistics]
+  GROUP BY CONVERT(VARCHAR(10), [DateTime], 104)
+  ORDER BY CONVERT(VARCHAR(10), [DateTime], 104) DESC
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/Query Jobs.sql
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/Query Jobs.sql	(revision 6481)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/Query Jobs.sql	(revision 6481)
@@ -0,0 +1,30 @@
+/****** Script for SelectTopNRows command from SSMS  ******/
+SELECT j.[JobId]
+      ,j.[JobState]
+      ,j.[ExecutionTimeMs]/1000/60/60 AS ExecutionTimeHours
+      ,DATALENGTH(jd.data)/1024.0/1024.0 AS MB
+      ,he.Name AS Experiment
+      ,he.DateCreated   
+      ,u.UserName
+      ,j.[LastHeartbeat]
+      ,j.[Priority]
+      ,j.[CoresNeeded]
+      ,j.[MemoryNeeded]
+      ,j.[IsPrivileged]
+      ,j.[Command]
+      ,j.[IsParentJob]   
+      ,j.[FinishWhenChildJobsFinished]
+      ,j.[ParentJobId]
+      , he.HiveExperimentId
+  FROM 
+	[HeuristicLab.Hive-3.4].[dbo].[Job] j
+	,[HeuristicLab.Hive-3.4].[dbo].[HiveExperiment] he
+	,[HeuristicLab.Authentication].dbo.aspnet_Users u
+	,[HeuristicLab.Hive-3.4].dbo.JobData jd
+  WHERE
+	j.HiveExperimentId = he.HiveExperimentId
+	AND j.JobId = jd.JobId
+	AND he.OwnerUserId = u.UserId
+	--AND he.DateCreated > '06-03-2011 10:30'
+	
+ORDER BY j.JobState, he.DateCreated DESC
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/Query Statistics.sql
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/Query Statistics.sql	(revision 6481)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/Query Statistics.sql	(revision 6481)
@@ -0,0 +1,12 @@
+SELECT [DateTime]
+      ,[Cores]
+      ,[FreeCores]
+      ,[CpuUtilization]
+      ,[Memory]
+      ,[FreeMemory]
+      ,[ExecutionTimeHours]
+      ,[ExecutionTimeFinished]
+      ,[StartToEndTimeFinished]
+  FROM [HeuristicLab.Hive-3.4].[dbo].[view_Statistics]
+  --WHERE [DateTime] > '2011-06-24 14:30'
+  ORDER BY [DateTime] DESC
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/web_services.config
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/web_services.config	(revision 6481)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Web/web_services.config	(revision 6481)
@@ -0,0 +1,130 @@
+﻿<?xml version="1.0"?>
+<configuration>
+
+  <configSections>
+    <sectionGroup name="applicationSettings" type="System.Configuration.ApplicationSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
+      <section name="HeuristicLab.Services.Hive.DataAccess.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false" />
+      <section name="HeuristicLab.Services.Hive.Common.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false" />
+    </sectionGroup>
+  </configSections>
+
+  <applicationSettings>
+    <HeuristicLab.Services.Hive.DataAccess.Settings>
+      <!-- Timeout for long running database command (storing or loading jobData) -->
+      <setting name="LongRunningDatabaseCommandTimeout" serializeAs="String">
+        <value>00:05:33</value>
+      </setting>
+    </HeuristicLab.Services.Hive.DataAccess.Settings>
+    
+    <HeuristicLab.Services.Hive.Common.Settings>
+      <!-- If a slave does not send a heartbeat for this time, it is set offline which means all of its jobs are rescheduled -->
+      <setting name="SlaveHeartbeatTimeout" serializeAs="String">
+        <value>00:01:00</value>
+      </setting>
+
+      <!-- When a job is in state `Calculating` this is the maximum time it does not have to send heartbeats, otherwise its rescheduled -->
+      <setting name="CalculatingJobHeartbeatTimeout" serializeAs="String">
+        <value>00:05:30</value>
+      </setting>
+
+      <!-- When a job is in state `Transferring` this is the maximum time it does not have to send heartbeats, otherwise its rescheduled --> 
+      <setting name="TransferringJobHeartbeatTimeout" serializeAs="String">
+        <value>00:05:30</value>
+      </setting>
+    </HeuristicLab.Services.Hive.Common.Settings>
+  </applicationSettings>
+  
+  <appSettings>
+     <add key="ChartImageHandler" value="storage=file;timeout=20;dir=C:\inetpub\temp\MsChartControlsTempImageFiles\;"/>
+  </appSettings>
+
+  <connectionStrings>
+    <add name="HeuristicLab.Authentication" connectionString="data source=localhost;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication"/>
+  </connectionStrings>
+  
+  <system.web>
+	<customErrors mode="Off"/>
+    <compilation debug="true" targetFramework="4.0" />
+    <membership>
+      <providers>
+        <clear/>
+        <add name="AspNetSqlMembershipProvider" type="System.Web.Security.SqlMembershipProvider" connectionStringName="HeuristicLab.Authentication" enablePasswordRetrieval="false" enablePasswordReset="true" requiresQuestionAndAnswer="false" requiresUniqueEmail="false" maxInvalidPasswordAttempts="5" minRequiredPasswordLength="6" minRequiredNonalphanumericCharacters="0" passwordAttemptWindow="10" applicationName="HeuristicLab.Authentication"/>
+      </providers>
+    </membership>
+    <roleManager enabled="true">
+      <providers>
+        <clear/>
+        <add name="AspNetSqlRoleProvider" type="System.Web.Security.SqlRoleProvider" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication"/>
+      </providers>
+    </roleManager>
+    <pages controlRenderingCompatibilityVersion="3.5" clientIDMode="AutoID"/>
+	<httpRuntime maxRequestLength="2147483647" />
+  </system.web>
+  
+  <system.serviceModel>
+    <diagnostics>
+      <messageLogging logEntireMessage="true" logMalformedMessages="true" logMessagesAtServiceLevel="true" logMessagesAtTransportLevel="true" maxMessagesToLog="3000"/>
+    </diagnostics>
+    
+    <bindings>
+      <wsHttpBinding>
+        <binding name="WSHttpBinding_IHiveService" 
+		  receiveTimeout="00:10:00"
+          sendTimeout="00:10:00" 
+		  maxBufferPoolSize="2147483647" 
+		  maxReceivedMessageSize="2147483647">
+          <readerQuotas maxStringContentLength="2147483647" maxArrayLength="2147483647" />
+          <security mode="Message">
+            <transport clientCredentialType="Certificate"/>
+            <message clientCredentialType="UserName" />
+          </security>
+        </binding>
+      </wsHttpBinding>
+    </bindings>
+    
+    <behaviors>
+      <serviceBehaviors>
+        <behavior name="ServiceBehaviour_IHiveService">
+          <!-- To avoid disclosing metadata information, set the value below to false and remove the metadata endpoint above before deployment -->
+          <serviceMetadata httpGetEnabled="true" httpsGetEnabled="false" />
+          <!-- To receive exception details in faults for debugging purposes, set the value below to true.  Set to false before deployment to avoid disclosing exception information -->
+          <serviceDebug httpHelpPageEnabled="true" includeExceptionDetailInFaults="true" />
+          <serviceAuthorization principalPermissionMode="UseAspNetRoles" roleProviderName="AspNetSqlRoleProvider" />
+          <serviceCredentials>
+            <serviceCertificate findValue="services.heuristiclab.com" x509FindType="FindBySubjectName" />
+            <userNameAuthentication userNamePasswordValidationMode="MembershipProvider" membershipProviderName="AspNetSqlMembershipProvider" />
+          </serviceCredentials>
+          <serviceSecurityAudit auditLogLocation="Application" suppressAuditFailure="false" messageAuthenticationAuditLevel="Failure" />
+          <serviceThrottling maxConcurrentCalls="100" />
+		  <dataContractSerializer maxItemsInObjectGraph="2147483647" />
+        </behavior>
+      </serviceBehaviors>
+	  
+	  <endpointBehaviors>
+        <behavior>
+          <dataContractSerializer maxItemsInObjectGraph="2147483647"/>
+        </behavior>
+      </endpointBehaviors>
+    </behaviors>
+
+    <services>
+      <service behaviorConfiguration="ServiceBehaviour_IHiveService" name="HeuristicLab.Services.Hive.HiveService">
+        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="" name="MexEndpoint" contract="IMetadataExchange" />
+        <endpoint binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IHiveService" name="WSHttpBinding_IHiveService" contract="HeuristicLab.Services.Hive.Common.ServiceContracts.IHiveService" />
+      </service>
+    </services>
+    
+    <serviceHostingEnvironment multipleSiteBindingsEnabled="true" />
+  </system.serviceModel>
+
+  <system.webServer>
+	<handlers>
+		<remove name="ChartImageHandler" />
+		<add name="ChartImageHandler" preCondition="integratedMode" verb="GET,HEAD,POST"
+			path="ChartImg.axd" type="System.Web.UI.DataVisualization.Charting.ChartHttpHandler,
+			System.Web.DataVisualization, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35" />
+	</handlers>
+    <directoryBrowse enabled="true"/>
+  </system.webServer>
+  
+</configuration>