Index: anches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Tests/Properties/AssemblyInfo.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Tests/Properties/AssemblyInfo.cs	(revision 6481)
+++ 	(revision )
@@ -1,35 +1,0 @@
-﻿using System.Reflection;
-using System.Runtime.CompilerServices;
-using System.Runtime.InteropServices;
-
-// General Information about an assembly is controlled through the following 
-// set of attributes. Change these attribute values to modify the information
-// associated with an assembly.
-[assembly: AssemblyTitle("HeuristicLab.Encodings.ScheduleEncoding.Tests")]
-[assembly: AssemblyDescription("")]
-[assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("FH-Hagenberg")]
-[assembly: AssemblyProduct("HeuristicLab.Encodings.ScheduleEncoding.Tests")]
-[assembly: AssemblyCopyright("Copyright © FH-Hagenberg 2011")]
-[assembly: AssemblyTrademark("")]
-[assembly: AssemblyCulture("")]
-
-// Setting ComVisible to false makes the types in this assembly not visible 
-// to COM components.  If you need to access a type in this assembly from 
-// COM, set the ComVisible attribute to true on that type.
-[assembly: ComVisible(false)]
-
-// The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("ad838a3c-c883-46ca-b7de-9af91413e240")]
-
-// Version information for an assembly consists of the following four values:
-//
-//      Major Version
-//      Minor Version 
-//      Build Number
-//      Revision
-//
-// You can specify all the values or you can default the Build and Revision Numbers 
-// by using the '*' as shown below:
-[assembly: AssemblyVersion("1.0.0.0")]
-[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/GanttChart.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/GanttChart.cs	(revision 6481)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/GanttChart.cs	(revision 6482)
@@ -11,5 +11,5 @@
     private IDictionary<int, Color> jobColors = new SortedDictionary<int, Color>();
     private IDictionary<string, int> rowNames = new Dictionary<string, int>();
-    
+
 
     public GanttChart() {
@@ -21,5 +21,5 @@
       if (!jobColors.ContainsKey(jobNr)) {
         Random r = new Random(jobNr + 1);
-        jobColors[jobNr] = Color.FromArgb (r.Next(256),r.Next(256),r.Next(256));
+        jobColors[jobNr] = Color.FromArgb(r.Next(256), r.Next(256), r.Next(256));
         chart.Legends[0].CustomItems.Clear();
         if (jobColors.Count > 1) {
@@ -28,5 +28,5 @@
             chart.Legends[0].CustomItems.Add(c, "Job#" + (i++));
           }
-        }   
+        }
       }
     }
@@ -39,7 +39,8 @@
     }
 
-    public void AddData(string rowName, int jobNr, double start, double end, string tooltip, bool showLabel = true) {
+    public void AddData(string rowName, int jobNr, int taskNr, double start, double end, string tooltip, bool showLabel = true) {
       AddRowName(rowName);
-      var point = new DataPoint(rowNames[rowName], new double[] { start, end });
+      AddJobColor(jobNr);
+      JobDataPoint point = new JobDataPoint(rowNames[rowName], new double[] { start, end }, jobNr, taskNr);
       point.Color = jobColors[jobNr];
       point.AxisLabel = rowName;
@@ -56,22 +57,40 @@
 
     void chart_MouseClick(object sender, MouseEventArgs e) {
-      var pos = e.Location;
-      var results = chart.HitTest(pos.X, pos.Y, false, ChartElementType.DataPoint);
-      foreach (DataPoint dp in chart.Series[0].Points) {
-        Color newColor = Color.FromArgb(255, dp.Color);
-        dp.Color = newColor;
-      }
-      foreach (var result in results) {
-        if (result.ChartElementType == ChartElementType.DataPoint) {
-          Color currentColor = chart.Series[0].Points[result.PointIndex].Color;
-          foreach (DataPoint dp in result.Series.Points) {
-            if (dp.Color != currentColor) {
-              Color newColor = Color.FromArgb(0, dp.Color);
-              dp.Color = newColor;
-            }
-          }
+      Point pos = e.Location;
+      HitTestResult[] results = chart.HitTest(pos.X, pos.Y, false, ChartElementType.DataPoint);
+      ResetDataColors();
+
+      foreach (HitTestResult result in results) {
+        if (result.ChartElementType == ChartElementType.DataPoint && result.Object.GetType() == typeof(JobDataPoint)) {
+          int currentJobNr = (result.Object as JobDataPoint).JobNr;
+          int currentTaskNr = (result.Object as JobDataPoint).TaskNr;
+
+          HighlightTaskAndJob(currentJobNr, currentTaskNr);
         }
       }
     }
+
+    public void ResetDataColors() {
+      foreach (DataPoint dp in chart.Series[0].Points) {
+        if (dp.GetType() == typeof(JobDataPoint))
+          dp.Color = jobColors[(dp as JobDataPoint).JobNr];
+      }
+    }
+
+    public void HighlightTaskAndJob(int jobNr, int taskNr) {
+      foreach (DataPoint dp in chart.Series[0].Points) {
+        if (dp.GetType() == typeof(JobDataPoint) && ((dp as JobDataPoint).JobNr == jobNr) && ((dp as JobDataPoint).TaskNr == taskNr)) {
+          Color newColor = Color.FromArgb(255, dp.Color);
+          dp.Color = newColor;
+        } else if (dp.GetType() == typeof(JobDataPoint) && ((dp as JobDataPoint).JobNr == jobNr)) {
+          Color newColor = Color.FromArgb(180, dp.Color);
+          dp.Color = newColor;
+        } else if (dp.GetType() == typeof(JobDataPoint) && !((dp as JobDataPoint).JobNr == jobNr)) {
+          Color newColor = Color.FromArgb(0, dp.Color);
+          dp.Color = newColor;
+        }
+      }
+    }
+
   }
 }
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/HeuristicLab.Encodings.ScheduleEncoding.Views-3.3.csproj
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/HeuristicLab.Encodings.ScheduleEncoding.Views-3.3.csproj	(revision 6481)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/HeuristicLab.Encodings.ScheduleEncoding.Views-3.3.csproj	(revision 6482)
@@ -56,4 +56,5 @@
       <DependentUpon>GanttChart.cs</DependentUpon>
     </Compile>
+    <Compile Include="JobDataPoint.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/JobDataPoint.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/JobDataPoint.cs	(revision 6482)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/JobDataPoint.cs	(revision 6482)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Windows.Forms.DataVisualization.Charting;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding.Views {
+  class JobDataPoint : DataPoint {
+
+    public JobDataPoint(double xValue, double[] yValues, int jobNr, int taskNr)
+      : base(xValue, yValues) {
+      JobNr = jobNr;
+      TaskNr = taskNr;
+    }
+
+    public int JobNr { get; set; }
+    public int TaskNr { get; set; }
+
+  }
+}
Index: anches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/Plugin.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/Plugin.cs	(revision 6481)
+++ 	(revision )
@@ -1,29 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.Encodings.ScheduleEncoding.Views {
-  [Plugin("HeuristicLab.Encodings.ScheduleEncoding.Views", "3.3.3.6414")]
-  [PluginFile("HeuristicLab.Encodings.ScheduleEncoding.Views-3.3.dll", PluginFileType.Assembly)]
-  public class HeuristicLabEncodingsScheduleEncodingViewsPlugin : PluginBase {
-  }
-}
Index: anches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/Properties/AssemblyInfo.cs	(revision 6481)
+++ 	(revision )
@@ -1,57 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Reflection;
-using System.Runtime.CompilerServices;
-using System.Runtime.InteropServices;
-
-// General Information about an assembly is controlled through the following 
-// set of attributes. Change these attribute values to modify the information
-// associated with an assembly.
-[assembly: AssemblyTitle("HeuristicLab.Encodings.ScheduleEncoding.Views")]
-[assembly: AssemblyDescription("Provides Views for ScheduleEncodings")]
-[assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("")]
-[assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2011 HEAL")]
-[assembly: AssemblyTrademark("")]
-[assembly: AssemblyCulture("")]
-
-// Setting ComVisible to false makes the types in this assembly not visible 
-// to COM components.  If you need to access a type in this assembly from 
-// COM, set the ComVisible attribute to true on that type.
-[assembly: ComVisible(false)]
-
-// The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("4da6c9ad-b15d-4960-b010-d12318948e2d")]
-
-// Version information for an assembly consists of the following four values:
-//
-//      Major Version
-//      Minor Version 
-//      Build Number
-//      Revision
-//
-// You can specify all the values or you can default the Build and Revision Numbers 
-// by using the '*' as shown below:
-// [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.6414")]
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/ScheduleView.Designer.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/ScheduleView.Designer.cs	(revision 6481)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/ScheduleView.Designer.cs	(revision 6482)
@@ -45,5 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.ganttChart = new GanttChart();
+      this.ganttChart = new HeuristicLab.Encodings.ScheduleEncoding.Views.GanttChart();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.SuspendLayout();
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/ScheduleView.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/ScheduleView.cs	(revision 6481)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/ScheduleView.cs	(revision 6482)
@@ -72,5 +72,5 @@
         foreach (ScheduledTask t in content.Resources[resCount].Tasks) {
           int categoryNr = 0;
-          string toolTip = "Task#";// +t.TaskNr;
+          string toolTip = "Task#" + t.TaskNr;
           string categoryName = "ScheduleTasks";
           if (t is ScheduledTask) {
@@ -79,7 +79,7 @@
             toolTip = categoryName + " - " + toolTip;
           }
-          ganttChart.AddJobColor(categoryNr);
           ganttChart.AddData("Resource" + r.Index,
             categoryNr,
+            t.TaskNr,
             t.StartTime,
             t.EndTime,
@@ -88,4 +88,8 @@
         resCount++;
       }
+    }
+
+    private void RefreshChartInformations(Schedule content) {
+
     }
 
Index: anches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs	(revision 6481)
+++ 	(revision )
@@ -1,29 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.Encodings.ScheduleEncoding {
-  [Plugin("HeuristicLab.Encodings.ScheduleEncoding", "3.3.3.6414")]
-  [PluginFile("HeuristicLab.Encodings.ScheduleEncoding-3.3.dll", PluginFileType.Assembly)]
-  public class HeuristicLabEncodingsScheduleEncodingPlugin : PluginBase {
-  }
-}
Index: anches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/Properties/AssemblyInfo.cs	(revision 6481)
+++ 	(revision )
@@ -1,57 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Reflection;
-using System.Runtime.CompilerServices;
-using System.Runtime.InteropServices;
-
-// General Information about an assembly is controlled through the following 
-// set of attributes. Change these attribute values to modify the information
-// associated with an assembly.
-[assembly: AssemblyTitle("HeuristicLab.Encodings.ScheduleEncoding")]
-[assembly: AssemblyDescription("HeuristicLab schedule encoding and related operators")]
-[assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("")]
-[assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2011 HEAL")]
-[assembly: AssemblyTrademark("")]
-[assembly: AssemblyCulture("")]
-
-// Setting ComVisible to false makes the types in this assembly not visible 
-// to COM components.  If you need to access a type in this assembly from 
-// COM, set the ComVisible attribute to true on that type.
-[assembly: ComVisible(false)]
-
-// The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("4da6c9ad-b15d-4960-b010-d12318948e2d")]
-
-// Version information for an assembly consists of the following four values:
-//
-//      Major Version
-//      Minor Version 
-//      Build Number
-//      Revision
-//
-// You can specify all the values or you can default the Build and Revision Numbers 
-// by using the '*' as shown below:
-// [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.6414")]
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Schedule.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Schedule.cs	(revision 6481)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Schedule.cs	(revision 6482)
@@ -123,4 +123,12 @@
         i++;
 
+      if (!lastScheduledTaskOfJob.ContainsKey(jobNr)) {
+        lastScheduledTaskOfJob.Add(jobNr, task);
+        task.TaskNr = 0;
+      } else {
+        task.TaskNr = lastScheduledTaskOfJob[jobNr].TaskNr + 1;
+        lastScheduledTaskOfJob[jobNr] = task;
+      }
+
       if (i >= affectedResource.Tasks.Count)
         affectedResource.Tasks.Add(task);
@@ -128,8 +136,4 @@
         affectedResource.Tasks.Insert(i, task);
 
-      if (!lastScheduledTaskOfJob.ContainsKey(jobNr))
-        lastScheduledTaskOfJob.Add(jobNr, task);
-      else
-        lastScheduledTaskOfJob[jobNr] = task;
     }
 
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/ScheduledTask.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/ScheduledTask.cs	(revision 6481)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/ScheduledTask.cs	(revision 6482)
@@ -31,4 +31,6 @@
     #region Properties
     [Storable]
+    public int TaskNr { get; set; }
+    [Storable]
     public int ResourceNr { get; set; }
     [Storable]
@@ -49,4 +51,5 @@
     protected ScheduledTask(ScheduledTask original, Cloner cloner)
       : base(original, cloner) {
+      this.TaskNr = original.TaskNr;
       this.ResourceNr = original.ResourceNr;
       this.Duration = original.Duration;
@@ -81,5 +84,7 @@
 
     public static bool AreEqual(ScheduledTask task1, ScheduledTask task2) {
-      return (task1.Duration == task2.Duration &&
+      return (
+        task1.TaskNr == task2.TaskNr &&
+        task1.Duration == task2.Duration &&
         task1.JobNr == task2.JobNr &&
         task1.ResourceNr == task2.ResourceNr &&
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.cs	(revision 6481)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.cs	(revision 6482)
@@ -63,7 +63,7 @@
           int categoryNr = t.JobNr;
           string categoryName = "Job" + categoryNr;
-          ganttChart.AddJobColor(categoryNr);
           ganttChart.AddData(categoryName,
             categoryNr,
+            t.TaskNr,
             lastEndTime + 1,
             lastEndTime + t.Duration,
Index: anches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs	(revision 6481)
+++ 	(revision )
@@ -1,29 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.Problems.Scheduling.Views {
-  [Plugin("HeuristicLab.Problems.Scheduling.Views", "3.3.3.6414")]
-  [PluginFile("HeuristicLab.Problems.Scheduling.Views-3.3.dll", PluginFileType.Assembly)]
-  public class HeuristicLabProblemsSchedulingViewsPlugin : PluginBase {
-  }
-}
Index: anches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs	(revision 6481)
+++ 	(revision )
@@ -1,55 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Reflection;
-using System.Runtime.InteropServices;
-
-// General Information about an assembly is controlled through the following 
-// set of attributes. Change these attribute values to modify the information
-// associated with an assembly.
-[assembly: AssemblyTitle("HeuristicLab.Problems.Scheduling")]
-[assembly: AssemblyDescription("TODO")]
-[assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("")]
-[assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2011 HEAL")]
-[assembly: AssemblyTrademark("")]
-[assembly: AssemblyCulture("")]
-
-// Setting ComVisible to false makes the types in this assembly not visible 
-// to COM components.  If you need to access a type in this assembly from 
-// COM, set the ComVisible attribute to true on that type.
-[assembly: ComVisible(false)]
-
-// The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("ABF1DB5E-5774-48AB-B65A-5CF405C0E2A8")]
-
-// Version information for an assembly consists of the following four values:
-//
-//      Major Version
-//      Minor Version 
-//      Build Number
-//      Revision
-//
-// You can specify all the values or you can default the Revision and Build Numbers 
-// by using the '*' as shown below:
-[assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.0.6414")]
Index: anches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Plugin.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Plugin.cs	(revision 6481)
+++ 	(revision )
@@ -1,29 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.Problems.Scheduling {
-  [Plugin("HeuristicLab.Problems.Scheduling", "3.3.3.6414")]
-  [PluginFile("HeuristicLab.Problems.Scheduling-3.3.dll", PluginFileType.Assembly)]
-  public class HeuristicLabProblemsSchedulingPlugin : PluginBase {
-  }
-}